/* ͷļ ----------------------------------------------------------------*/
#include "bsp_usb.h"
/* ˽к궨 ----------------------------------------------------------------*/

/* ˽Ͷ --------------------------------------------------------------*/

/* չ ------------------------------------------------------------------*/

/* ˽б ------------------------------------------------------------------*/
/* Global Variable */
__attribute__ ((aligned(4))) UINT8  RxBuffer[MAX_PACKET_SIZE] ;      // IN, must even address
__attribute__ ((aligned(4))) UINT8  TxBuffer[MAX_PACKET_SIZE] ;      // OUT, must even address
/* жϺ ----------------------------------------------------------------*/

/*  --------------------------------------------------------------------*/
/*******************************************************************************
* Function Name  : Set_USBConfig
* Description    : Set USB clock.
* Input          : None
* Return         : None
*******************************************************************************/
static void USBHD_ClockCmd(UINT32 RCC_USBCLKSource,FunctionalState NewState)
{
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, NewState);
    EXTEN->EXTEN_CTR |= EXTEN_USBHD_IO_EN;
    RCC_USBCLKConfig(RCC_USBCLKSource);             //USBclk=PLLclk/1.5=48Mhz
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_USBHD, NewState);
}
void bsp_usbhd_init(void)
{
    USBHD_ClockCmd(RCC_USBCLKSource_PLLCLK_1Div5,ENABLE);
    pHOST_RX_RAM_Addr = RxBuffer;
    pHOST_TX_RAM_Addr = TxBuffer;
    USB_HostInit();  //ʼUSBģʽ
}
/*ݳ*/
UINT8 TXDUsbCH341BulkOut( PUINT8 pBuf,UINT8 len )  // 341
{
    UINT8 TxCnt,s,endp = ThisUsbDev.GpVar[1];

    printf("CH341 Out data: \r\n");
    while ( len )
    {
        Delay_Us( 200 );
        R8_UH_TX_LEN = len >= 32 ? 32 : len;
        for ( TxCnt = 0; TxCnt != R8_UH_TX_LEN; TxCnt ++ ) {
            TxBuffer[ TxCnt ] = *pBuf;
            printf("x%02X ",TxBuffer[ TxCnt ]);
            pBuf ++;
        }
        s = USBHostTransact( USB_PID_OUT << 4 | (endp & 0x7F), endp & 0x80 ? RB_UH_R_TOG | RB_UH_T_TOG : 0, 0 );  // OUT
        if ( s == ERR_SUCCESS ){
            len -= R8_UH_TX_LEN;
            endp ^= 0x80;  // ͬ־ת
            ThisUsbDev.GpVar[1] = endp;  // ͬ־λ
        }
        else
        {
            return( s );
            printf("\r\n");
        }
    }
    printf("\r\n");

    return ERR_SUCCESS;
}
/*ݽճȣݴRxBuffer*/
UINT8 RXDUsbCH341BulkIn( void )  // 341
{
    UINT8 i,s,len,endp = ThisUsbDev.GpVar[0];

    // CH559,ȡ,NAK
    s = USBHostTransact( USB_PID_IN << 4 | (endp & 0x7F), endp & 0x80 ? RB_UH_R_TOG | RB_UH_T_TOG : 0, 0 );

    if ( s == ERR_SUCCESS )
    {
        endp ^= 0x80;  // ͬ־ת
        ThisUsbDev.GpVar[0] = endp;  // ͬ־λ
        len = R8_USB_RX_LEN;  // յݳ
        if ( len )
        {
            printf("CH341 In data: \r\n");
            for ( i = 0; i < len; i ++ )
                printf("x%02X ",(UINT16)(RxBuffer[i]) );
            printf("\r\n");
        }
        return len;
    }
    else if ( s != ( USB_PID_NAK | ERR_USB_TRANSFER ) )
        printf("CH341 error %02x\r\n",(UINT16)s);// ǶϿ

    return 0;
}


