/* ͷļ ----------------------------------------------------------------*/
#include "app.h"
/* ˽к궨 ----------------------------------------------------------------*/

/* ˽Ͷ --------------------------------------------------------------*/

/* չ ------------------------------------------------------------------*/

/* ˽б ------------------------------------------------------------------*/
static __IO uint32_t MillCnt = 0;
__attribute__ ((aligned(4))) UINT8  Com_Buffer[128];
UINT8 tmpBuf[6] = {'1','2','3','4','5','\0'};
UINT8 usbtxglag = 0,rxlen = 0;
uint16_t usb_outtime = 0;
/*  --------------------------------------------------------------------*/
/***********************************************************************************************

                                       ӦӺ

************************************************************************************************/

/***********************************************************************************************

                                       Ӧ

************************************************************************************************/
static void LED_Task(void)
{
    static uint8_t i=0;
    static uint32_t LastTime = 0;

    if(Tim_CheckTimeOut(LastTime, MillCnt, 100) == 0)
        return;
    LastTime = MillCnt;
    //============Ϊִ================
    led1_level((i==LED_OFF) ? (i=LED_ON):(i=LED_OFF));
}
static void USB_Task(void)
{
    uint8_t s;

    s = ERR_SUCCESS;
    if ( R8_USB_INT_FG & RB_UIF_DETECT )
    {
        R8_USB_INT_FG = RB_UIF_DETECT ;      //⵽USB豸ӻϿ

        s = AnalyzeRootHub( );               //״̬

        if ( s == ERR_USB_CONNECT )          //⵽豸
        {
            printf( "New Device In\r\n" );
            FoundNewDev = 1;
        }
        if( s == ERR_USB_DISCON )            //⵽豸Ͽ
        {
            printf( "Device Out\r\n" );
        }
    }
    if ( FoundNewDev || s == ERR_USB_CONNECT )
    {//⵽USB豸
        FoundNewDev = 0;
        Delay_Ms( 200 );// USB豸ղδȶ,ʵȴUSB豸ٺ,ζ
        s = InitRootDevice( Com_Buffer );
        if ( s == ERR_SUCCESS )
        {
            printf( "Device Enum Succeed\r\n" );
        }
        else
        {
            printf( "Device Enum Failed\r\n" );
            printf( "EnumAllRootDev err = %02X\r\n", (UINT16)s );
        }
    }
    if(ThisUsbDev.DeviceStatus == ROOT_DEV_SUCCESS)
    {
        if((usbtxglag == 0) && (usb_outtime == 0))
        {
            if(TXDUsbCH341BulkOut( tmpBuf,6 ) == ERR_SUCCESS)
            {
                usb_outtime = 2000;
                usbtxglag = 1;
                rxlen = 0;
                rxlen += RXDUsbCH341BulkIn();
                printf( "USB CH341 TX Succeed!\r\n" );
            }
            else {
                usb_outtime = 2000;
                printf( "USB CH341 TX Failed!\r\n" );
            }
        }
        else
        {
            rxlen += RXDUsbCH341BulkIn();
            if((rxlen >= 4) || (usb_outtime == 0))
            {
                usbtxglag = 0;
                usb_outtime = 0;
                rxlen = 0;
            }
        }
    }
}
/***********************************************************************************************

                                       Ӧ¼жϣ

************************************************************************************************/
static void Timer_Handler(void)
{
    MillCnt++;
    if(usb_outtime > 0)usb_outtime--;
}
/***********************************************************************************************

                                       APP

************************************************************************************************/
void app_main_init(void)
{
    BSP_Init();
    SysTime_SetHandler(Timer_Handler);
}
void app_main_loop(void)
{
    printf("Boot up successfully!\r\n");
	for(;;)
	{
	    LED_Task();
	    USB_Task();
	}
}

